//Copyright (C) 2013 The Computational Science Resarch Program (CSRP), RIKEN
//All rights reserved.
//
//This file is part of RIKEN Integrated Cell Simulator for the K-Computer(RICS-K).
//
//RICS-K is free software: you can redistribute it and/or modify
//it under the terms of the GNU General Public License as published by
//the Free Software Foundation, either version 3 of the License, or
//(at your option) any later version.
//
//RICS-K is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with RICS-K.  If not, see <http://www.gnu.org/licenses/>.


#include <iostream>
#include <sstream>

#include <Foundation/error.h>
#include <Foundation/util.h>

#include "SklSolverFoundation.h"

using namespace std;

int SklSolverFoundation::OpenLogFile()
{
#ifdef _NO_LOGFILE
	return 1;
#endif //_NO_LOGFILE

	// create log file name
	string logfilename;

#ifdef SPHERE175
	logfilename = UtilStrFormat("%08d.log", para_cmp->GetMyID(0));	//2009.12.08
#else
	logfilename = UtilStrFormat("%08d.log", ParaMngr.GetMyID(0));
#endif

	// open file
#ifndef _NO_MESSAGE
	MESSAGE(string("Open Log file ") + logfilename);
#else
	MESSAGE(string("Open Log file"),0);
#endif //_NO_MESSAGE
	cfg.logfile.open(logfilename.c_str());

	// bind file to cout/cerr stream
#ifndef _NO_MESSAGE
	MESSAGE("Binding to Message Stream");
#else
	MESSAGE("Binding to Message Stream",0);
#endif //_NO_MESSAGE
	cout.tie(cfg.logfile.is_open()? &cfg.logfile: NULL);
	cerr.tie(cfg.logfile.is_open()? &cfg.logfile: NULL);

	return 1;
}

int SklSolverFoundation::CloseLogFile()
{
#ifdef _NO_LOGFILE
	return 1;
#endif //_NO_LOGFILE

	cfg.logfile.close();
	return 1;
}

