//Copyright (C) 2013 The Computational Science Resarch Program (CSRP), RIKEN
//All rights reserved.
//
//This file is part of RIKEN Integrated Cell Simulator for the K-Computer(RICS-K).
//
//RICS-K is free software: you can redistribute it and/or modify
//it under the terms of the GNU General Public License as published by
//the Free Software Foundation, either version 3 of the License, or
//(at your option) any later version.
//
//RICS-K is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with RICS-K.  If not, see <http://www.gnu.org/licenses/>.


#include <Skl.h>
#include "const.h"

// default values
// const int VC = 4;  // system default virtual cell size
const int VC = 2;  // system default virtual cell size

// Avogadro constant number
const SKL_REAL NA_IUPAC         = 6.0221367e23;    // IUPAC defined
const SKL_REAL NA_IUPAC_detail  = 6.022136736e23;  // IUPAC defined in detail
const SKL_REAL NA_CODATA        = 6.02214179e23;   // CODATA defined
const SKL_REAL NA_CODATA_detail = 6.0221417930e23; // CODATA defined in detail
const SKL_REAL default_NA = NA_IUPAC;

// configuration file tag name
const char* cfg_param_dt = "dt";
const char* cfg_param_lu = "length_unit";
const char* cfg_param_tu = "time_unit";
const char* cfg_param_vu = "molecular_unit";

const char* cfg_elem_output = "output";

const char* cfg_elem_fldout         = "field";
const char* cfg_param_fldout_target = "material";

const char* cfg_elem_prbout           = "field";
const char* cfg_param_prbout_target   = "material";
const char* cfg_param_prbout_point_x  = "px";
const char* cfg_param_prbout_point_y  = "py";
const char* cfg_param_prbout_point_z  = "pz";
const char* cfg_param_prbout_interval = "interval";
const char* cfg_param_prbout_fname    = "fname";

const char* cfg_elem_simsetting = "sim_setting";

// configuration default
const SKL_REAL default_dt = 1e-3; // 1[ms]

const char*  prbout_defalut_file = "probe.csv";
const char   prbout_separater    = ',';
const size_t prbout_colum_width  = 8;

// array data label
const char* ary_label_mat_org  = "MatOrgFld";
const char* ary_label_mat_new  = "MatUpdFld";
const char* ary_label_mol_org  = "MolOrgFld";
const char* ary_label_mol_new  = "MolUpdFld";

const char* ary_label_mtb_res  = "MtbResFld";
const char* ary_label_diff_res = "DifResFld";

