//Copyright (C) 2013 The Computational Science Resarch Program (CSRP), RIKEN
//All rights reserved.
//
//This file is part of RIKEN Integrated Cell Simulator for the K-Computer(RICS-K).
//
//RICS-K is free software: you can redistribute it and/or modify
//it under the terms of the GNU General Public License as published by
//the Free Software Foundation, either version 3 of the License, or
//(at your option) any later version.
//
//RICS-K is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with RICS-K.  If not, see <http://www.gnu.org/licenses/>.


#ifndef __ECELL_IF_H__
#define __ECELL_IF_H__

#include <string>

#ifndef _WITHOUT_ECELL

#include <ecell_config.h>

#define VERSION_INT(MJ,MI,MC) \
	  ((MJ) * 1000000) \
	+ ((MI) * 10000) \
	+ ((MC) * 1)
#define ECELL_VERSION_INT \
	  VERSION_INT(ECELL_MAJOR_VERSION,ECELL_MINOR_VERSION,ECELL_MICRO_VERSION)

#if ECELL_VERSION_INT < VERSION_INT(3,1,105)
	#error E-Cell 3.1.105 or later is needed
#endif

#include "EmlModel.h"
#include "emcsim.h"

void InitECellIf();
void FinalizeECellIf();

//std::string poly2string(const libecs::Polymorph p);
std::string poly2string(const libecs::Polymorph p);

#else // _WITHOUT_ECELL

#define InitECellIf()
#define FinalizeECellIf();

#endif // _WITHOUT_ECELL
#endif // __ECELL_IF_H__

