//Copyright (C) 2013 The Computational Science Resarch Program (CSRP), RIKEN
//All rights reserved.
//
c Copyright (C) 2013 The Computational Science Resarch Program (CSRP), RIKEN
c All rights reserved.
c This file is part of RIKEN Integrated Cell Simulator for the K-Computer(RICS-K).
c 
c  RICS-K is free software: you can redistribute it and/or modify
c it under the terms of the GNU General Public License as published by
c the Free Software Foundation, either version 3 of the License, or
c (at your option) any later version.
c
c RICS-K is distributed in the hope that it will be useful,
c but WITHOUT ANY WARRANTY; without even the implied warranty of
c MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c GNU General Public License for more details.
c 
c You should have received a copy of the GNU General Public License
c along with RICS-K.  If not, see <http://www.gnu.org/licenses/>.

      subroutine exptim(P1,P0,
     +                  fx,fy,fz,
     +                  Mt,Fm,Qm,
     +                  R,S0,
     +                  Vfi,Sm,
     +                  dt,dxi,dyi,dzi,
     +                  imax,jmax,kmax,vc)
c
      implicit none
c
      real dt,dxi,dyi,dzi
      integer imax,jmax,kmax,vc
      real P1 (0-vc:imax+vc-1,0-vc:jmax+vc-1,0-vc:kmax+vc-1)
      real P0 (0-vc:imax+vc-1,0-vc:jmax+vc-1,0-vc:kmax+vc-1)
      real fx (0-vc:imax+vc-1,0-vc:jmax+vc-1,0-vc:kmax+vc-1)
      real fy (0-vc:imax+vc-1,0-vc:jmax+vc-1,0-vc:kmax+vc-1)
      real fz (0-vc:imax+vc-1,0-vc:jmax+vc-1,0-vc:kmax+vc-1)
      real R  (0-vc:imax+vc-1,0-vc:jmax+vc-1,0-vc:kmax+vc-1)
      real Mt (0-vc:imax+vc-1,0-vc:jmax+vc-1,0-vc:kmax+vc-1)
      real Fm (0-vc:imax+vc-1,0-vc:jmax+vc-1,0-vc:kmax+vc-1)
      real Qm (0-vc:imax+vc-1,0-vc:jmax+vc-1,0-vc:kmax+vc-1)
      real S0 (0-vc:imax+vc-1,0-vc:jmax+vc-1,0-vc:kmax+vc-1)
      real Vfi(0-vc:imax+vc-1,0-vc:jmax+vc-1,0-vc:kmax+vc-1)
      real Sm (0-vc:imax+vc-1,0-vc:jmax+vc-1,0-vc:kmax+vc-1)
c
      integer i,j,k
c
      do k=0,kmax-1
      do j=0,jmax-1
      do i=0,imax-1
c
        P1(i,j,k) = P0(i,j,k)
     +   + dt * (
     +       (fx(i+1,j,k) - fx(i,j,k)) * Vfi(i,j,k) * dxi
     +     + (fy(i,j+1,k) - fy(i,j,k)) * Vfi(i,j,k) * dyi
     +     + (fz(i,j,k+1) - fz(i,j,k)) * Vfi(i,j,k) * dzi
     +     - Mt(i,j,k) * Vfi(i,j,k) * dxi * dyi * dzi
c     +     - Fm(i,j,k) * Sm(i,j,k) * Vfi(i,j,k) * dxi * dyi * dzi
     +     - Qm(i,j,k) * Vfi(i,j,k) * dxi * dyi * dzi
     +     + R(i,j,k)
     +     + S0(i,j,k))
c
      enddo
      enddo
      enddo
c
      return
      end
c

