//Copyright (C) 2013 The Computational Science Resarch Program (CSRP), RIKEN
//All rights reserved.
//
//This file is part of RIKEN Integrated Cell Simulator for the K-Computer(RICS-K).
//
//RICS-K is free software: you can redistribute it and/or modify
//it under the terms of the GNU General Public License as published by
//the Free Software Foundation, either version 3 of the License, or
//(at your option) any later version.
//
//RICS-K is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with RICS-K.  If not, see <http://www.gnu.org/licenses/>.


#ifndef __ADVECTION_DEFINE_H__
#define __ADVECTION_DEFINE_H__

#include <Skl.h>
#include <SklUtil.h>

#include <vector>

#include <Foundation/const.h>
#include <Foundation/util.h>
#include <Foundation/error.h>
#include <Foundation/datatype.h>
#include <Foundation/api.h>

// domain direction
#define X_MINUS 0
#define Y_MINUS 1
#define Z_MINUS 2
#define X_PLUS  3
#define Y_PLUS  4
#define Z_PLUS  5

// Velocity file
struct VelFile {
	string   matName;
	SKL_REAL time;
	string   attr;
};

#endif /*__ADVECTION_DEFINE_H__*/
