//Copyright (C) 2013 The Computational Science Resarch Program (CSRP), RIKEN
//All rights reserved.
//
//This file is part of RIKEN Integrated Cell Simulator for the K-Computer(RICS-K).
//
//RICS-K is free software: you can redistribute it and/or modify
//it under the terms of the GNU General Public License as published by
//the Free Software Foundation, either version 3 of the License, or
//(at your option) any later version.
//
//RICS-K is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with RICS-K.  If not, see <http://www.gnu.org/licenses/>.


#ifndef _FORTRAN_FUNC_ADVECTION_H_
#define _FORTRAN_FUNC_ADVECTION_H_

#include "Skl.h"

extern "C" {

	void calc_advection_(const SKL_REAL *P0, SKL_REAL *ad,
				const SKL_REAL *uvel, const SKL_REAL *vvel, const SKL_REAL *wvel,
				const SKL_REAL *vfi,
				const SKL_REAL *ax, const SKL_REAL *ay, const SKL_REAL *az,
				int *I, int *J, int *K, const int *vc,
				const SKL_REAL *dx, const SKL_REAL *dy, const SKL_REAL *dz);

	void exptimadv_(SKL_REAL *P1, SKL_REAL *ad,
			const SKL_REAL *dt,
			const int *imax, const int *jmax, const int *kmax,
			const int *vc);

}

#endif /* _FORTRAN_FUNC_ADVECTION_H_ */
