//Copyright (C) 2013 The Computational Science Resarch Program (CSRP), RIKEN
//All rights reserved.
//
c Copyright (C) 2013 The Computational Science Resarch Program (CSRP), RIKEN
c All rights reserved.
c This file is part of RIKEN Integrated Cell Simulator for the K-Computer(RICS-K).
c 
c  RICS-K is free software: you can redistribute it and/or modify
c it under the terms of the GNU General Public License as published by
c the Free Software Foundation, either version 3 of the License, or
c (at your option) any later version.
c
c RICS-K is distributed in the hope that it will be useful,
c but WITHOUT ANY WARRANTY; without even the implied warranty of
c MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c GNU General Public License for more details.
c 
c You should have received a copy of the GNU General Public License
c along with RICS-K.  If not, see <http://www.gnu.org/licenses/>.

      subroutine calccoef(cx,cy,cz,Dx,Dy,Dz,
     +                    nID,e,eqns,imax,jmax,kmax,vc)
c
      implicit none
c
      integer nID(0:5)
      integer eqns,e
      integer imax,jmax,kmax,vc
      real cx(-vc:imax+vc-1,-vc:jmax+vc-1,-vc:kmax+vc-1,0:eqns-1)
      real cy(-vc:imax+vc-1,-vc:jmax+vc-1,-vc:kmax+vc-1,0:eqns-1)
      real cz(-vc:imax+vc-1,-vc:jmax+vc-1,-vc:kmax+vc-1,0:eqns-1)
      real Dx(-vc:imax+vc-1,-vc:jmax+vc-1,-vc:kmax+vc-1,0:eqns-1)
      real Dy(-vc:imax+vc-1,-vc:jmax+vc-1,-vc:kmax+vc-1,0:eqns-1)
      real Dz(-vc:imax+vc-1,-vc:jmax+vc-1,-vc:kmax+vc-1,0:eqns-1)
c
      integer i,j,k
c
c     calc boundary definition D coef. with Harmonic meaning
c
c     X-direction
c
      do k=0-vc,kmax+vc-1
      do j=0-vc,jmax+vc-1
      do i=0,imax
c
      if ((Dx(i-1,j,k,e).eq.0.0).and.(Dx(i,j,k,e).eq.0.0)) then
          cx(i,j,k,e) = 0.0
      else
          cx(i,j,k,e) =
     +      2.0*Dx(i-1,j,k,e)*Dx(i,j,k,e)/(Dx(i-1,j,k,e)+Dx(i,j,k,e))
      end if
c
      enddo
      enddo
      enddo
c
c     Y-direction
c
      do k=0-vc,kmax+vc-1
      do j=0,jmax
      do i=0-vc,imax+vc-1
c
      if ((Dy(i,j-1,k,e).eq.0.0).or.(Dy(i,j,k,e).eq.0.0)) then
          cy(i,j,k,e) = 0.0
      else
          cy(i,j,k,e) =
     +      2.0*Dy(i,j-1,k,e)*Dy(i,j,k,e)/(Dy(i,j-1,k,e)+Dy(i,j,k,e))
      end if
c
      enddo
      enddo
      enddo
c
c     Z-direction
c
      do k=0,kmax
      do j=0-vc,jmax+vc-1
      do i=0-vc,imax+vc-1
c
      if ((Dz(i,j,k-1,e).eq.0.0).and.(Dz(i,j,k,e).eq.0.0)) then
          cz(i,j,k,e) = 0.0
      else
          cz(i,j,k,e) =
     +      2.0*Dz(i,j,k-1,e)*Dz(i,j,k,e)/(Dz(i,j,k-1,e)+Dz(i,j,k,e))
      end if
c
      enddo
      enddo
      enddo
c
      return
      end
