/*
 * Copyright (c) RIKEN, Japan. All right reserved. 2007-2010
 *
 */

#ifdef MAKE_MODEL

#include <SklUtil.h>

#include <Foundation/const.h>
#include <Foundation/util.h>
#include <Foundation/error.h>
#include <Foundation/datatype.h>
#include <Foundation/api.h>
#include <Foundation/SklSolverFoundation.h>

#include "FortranFuncMembEq.h"
#include "MembraneSolv.h"

int MembraneSolv::MakeChannelDen()
{
	MESSAGE("Make Channel Density ...", 0);

	const int vc  = VC;

	const int I   = cfg.Pdiv.size[0];
	const int J   = cfg.Pdiv.size[1];
	const int K   = cfg.Pdiv.size[2];

	const int hix = cfg.Pdiv.head[0];
	const int hiy = cfg.Pdiv.head[1];
	const int hiz = cfg.Pdiv.head[2];

	SKL_REAL xscale = SKL_REAL(cfg.size[0]) / 16.0;
	SKL_REAL yscale = SKL_REAL(cfg.size[1]) / 16.0;
	SKL_REAL zscale = SKL_REAL(cfg.size[2]) / 16.0;

	// int xmin = 0 * xscale;	int xmax = 15 * xscale;
	// int ymin = 6 * yscale;	int ymax =  9 * yscale;
	// int zmin = 6 * zscale;	int zmax =  9 * zscale;

	SKL_REAL memMinX =  0.0;
	SKL_REAL memMaxX = 16.0;
	SKL_REAL memMinY =  6.5;
	SKL_REAL memMaxY =  9.5;
	SKL_REAL memMinZ =  6.5;
	SKL_REAL memMaxZ =  9.5;
	int xmin = int(memMinX * xscale);
	int xmax = int(memMaxX * xscale);
	int ymin = int(memMinY * yscale);
	int ymax = int(memMaxY * yscale);
	int zmin = int(memMinZ * zscale);
	int zmax = int(memMaxZ * zscale);

	size_t chaid = 0;

	const SKL_REAL *den = UtilGetS4DN(DenCha, chaid);

	size_t sz = (I+2*vc)*(J+2*vc)*(K+2*vc);
	int *mask = new int[sz];

	makevolume_(den,&I,&J,&K,&vc,&xmin,&xmax,&ymin,&ymax,&zmin,&zmax,
			&hix,&hiy,&hiz,mask);

	delete [] mask;

	DenCha->CommBndCell(DenCha->GetVCellSize());

	return 1;
}

#endif // MAKE_MODEL
