//Copyright (C) 2013 The Computational Science Resarch Program (CSRP), RIKEN
//All rights reserved.
//
c Copyright (C) 2013 The Computational Science Resarch Program (CSRP), RIKEN
c All rights reserved.
c This file is part of RIKEN Integrated Cell Simulator for the K-Computer(RICS-K).
c 
c  RICS-K is free software: you can redistribute it and/or modify
c it under the terms of the GNU General Public License as published by
c the Free Software Foundation, either version 3 of the License, or
c (at your option) any later version.
c
c RICS-K is distributed in the hope that it will be useful,
c but WITHOUT ANY WARRANTY; without even the implied warranty of
c MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c GNU General Public License for more details.
c 
c You should have received a copy of the GNU General Public License
c along with RICS-K.  If not, see <http://www.gnu.org/licenses/>.

      subroutine calcFluxCha(fgmn,R,
     +                       SW,Fuzzy,Den,
     +                       P0gm,P0gn,Evm,Evn,
     +                       KCha,KeCha,nx,ny,nz,
     +                       imax,jmax,kmax,vc,
     +                       flag,coef)
c
      implicit none
c
      integer flag
      integer coef(1:3)
      integer imax,jmax,kmax,vc
      real fgmn(-vc:imax+vc-1,-vc:jmax+vc-1,-vc:kmax+vc-1)
      real SW(-vc:imax+vc-1,-vc:jmax+vc-1,-vc:kmax+vc-1)
      real Fuzzy(-vc:imax+vc-1,-vc:jmax+vc-1,-vc:kmax+vc-1)
      real Den(-vc:imax+vc-1,-vc:jmax+vc-1,-vc:kmax+vc-1)
      real P0gm(-vc:imax+vc-1,-vc:jmax+vc-1,-vc:kmax+vc-1)
      real P0gn(-vc:imax+vc-1,-vc:jmax+vc-1,-vc:kmax+vc-1)
      real Evm(-vc:imax+vc-1,-vc:jmax+vc-1,-vc:kmax+vc-1)
      real Evn(-vc:imax+vc-1,-vc:jmax+vc-1,-vc:kmax+vc-1)
      real KCha(-vc:imax+vc-1,-vc:jmax+vc-1,-vc:kmax+vc-1)
      real KeCha(-vc:imax+vc-1,-vc:jmax+vc-1,-vc:kmax+vc-1)
      real nx(-vc:imax+vc-1,-vc:jmax+vc-1,-vc:kmax+vc-1)
      real ny(-vc:imax+vc-1,-vc:jmax+vc-1,-vc:kmax+vc-1)
      real nz(-vc:imax+vc-1,-vc:jmax+vc-1,-vc:kmax+vc-1)
      real R
      real fluxchannelvoxel
c
      integer i,j,k
      real nnx,nny,nnz
c
c
      do k=0,kmax-1
      do j=0,jmax-1
      do i=0,imax-1
c
      nnx = nx(i,j,k) * real(flag) + real(coef(1))
      nny = ny(i,j,k) * real(flag) + real(coef(2))
      nnz = nz(i,j,k) * real(flag) + real(coef(3))
c
      fgmn(i,j,k) = fgmn(i,j,k)
     + + fluxchannelvoxel(
     +      R,SW,Fuzzy,Den,
     +      p0gm,P0gn,Evm,Evn,
     +      KCha,KeCha,
     +      nnx,nny,nnz,
     +      i,j,k,
     +      imax,jmax,kmax,vc)
c
c
      enddo
      enddo
      enddo
c
      return
      end

