//Copyright (C) 2013 The Computational Science Resarch Program (CSRP), RIKEN
//All rights reserved.
//
c Copyright (C) 2013 The Computational Science Resarch Program (CSRP), RIKEN
c All rights reserved.
c This file is part of RIKEN Integrated Cell Simulator for the K-Computer(RICS-K).
c 
c  RICS-K is free software: you can redistribute it and/or modify
c it under the terms of the GNU General Public License as published by
c the Free Software Foundation, either version 3 of the License, or
c (at your option) any later version.
c
c RICS-K is distributed in the hope that it will be useful,
c but WITHOUT ANY WARRANTY; without even the implied warranty of
c MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c GNU General Public License for more details.
c 
c You should have received a copy of the GNU General Public License
c along with RICS-K.  If not, see <http://www.gnu.org/licenses/>.

      subroutine calcFluxPum(fgmn,fgnm,R,SW,Fuzzy,Den,
     +                       p0gm,p0hm,Vmax,Km,
     +                       nxm,nym,nzm,
     +                       nxn,nyn,nzn,
     +                       imax,jmax,kmax,vc,
     +                       flag,coef)
c
      implicit none
c
      integer flag
      integer coef(1:3)
      integer imax,jmax,kmax,vc
      real fgmn(-vc:imax+vc-1,-vc:jmax+vc-1,-vc:kmax+vc-1)
      real fgnm(-vc:imax+vc-1,-vc:jmax+vc-1,-vc:kmax+vc-1)
      real SW(-vc:imax+vc-1,-vc:jmax+vc-1,-vc:kmax+vc-1)
      real Fuzzy(-vc:imax+vc-1,-vc:jmax+vc-1,-vc:kmax+vc-1)
      real Den(-vc:imax+vc-1,-vc:jmax+vc-1,-vc:kmax+vc-1)
      real p0gm(-vc:imax+vc-1,-vc:jmax+vc-1,-vc:kmax+vc-1)
      real p0hm(-vc:imax+vc-1,-vc:jmax+vc-1,-vc:kmax+vc-1)
      real Vmax(-vc:imax+vc-1,-vc:jmax+vc-1,-vc:kmax+vc-1)
      real Km(-vc:imax+vc-1,-vc:jmax+vc-1,-vc:kmax+vc-1)
      real nxm(-vc:imax+vc-1,-vc:jmax+vc-1,-vc:kmax+vc-1)
      real nym(-vc:imax+vc-1,-vc:jmax+vc-1,-vc:kmax+vc-1)
      real nzm(-vc:imax+vc-1,-vc:jmax+vc-1,-vc:kmax+vc-1)
      real nxn(-vc:imax+vc-1,-vc:jmax+vc-1,-vc:kmax+vc-1)
      real nyn(-vc:imax+vc-1,-vc:jmax+vc-1,-vc:kmax+vc-1)
      real nzn(-vc:imax+vc-1,-vc:jmax+vc-1,-vc:kmax+vc-1)
      real R
      real fluxpumpvoxel
c
      integer i,j,k
      real nnxn,nnyn,nnzn
c
      do k=0,kmax-1
      do j=0,jmax-1
      do i=0,imax-1
c
      nnxn = nxn(i,j,k) * real(flag) + real(coef(1))
      nnyn = nyn(i,j,k) * real(flag) + real(coef(2))
      nnzn = nzn(i,j,k) * real(flag) + real(coef(3))
c
      fgmn(i,j,k)
     +  = fgmn(i,j,k)
     +  + fluxpumpvoxel(R,SW,Fuzzy,Den,
     +          p0gm,p0hm,Vmax,Km,
     +          0,0,0,i,j,k,
     +          imax,jmax,kmax,vc)
c
      fgnm(i,j,k)
     +  = fgnm(i,j,k)
     +  - fluxpumpvoxel(R,SW,Fuzzy,Den,
     +          p0gm,p0hm,Vmax,Km,
     +          nnxn,nnyn,nnzn,i,j,k,
     +          imax,jmax,kmax,vc)
c
      enddo
      enddo
      enddo
c
      return
      end
