//Copyright (C) 2013 The Computational Science Resarch Program (CSRP), RIKEN
//All rights reserved.
//
c Copyright (C) 2013 The Computational Science Resarch Program (CSRP), RIKEN
c All rights reserved.
c This file is part of RIKEN Integrated Cell Simulator for the K-Computer(RICS-K).
c 
c  RICS-K is free software: you can redistribute it and/or modify
c it under the terms of the GNU General Public License as published by
c the Free Software Foundation, either version 3 of the License, or
c (at your option) any later version.
c
c RICS-K is distributed in the hope that it will be useful,
c but WITHOUT ANY WARRANTY; without even the implied warranty of
c MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c GNU General Public License for more details.
c 
c You should have received a copy of the GNU General Public License
c along with RICS-K.  If not, see <http://www.gnu.org/licenses/>.

      subroutine calcFluxPumTR(qhm,TR,SW,Fuzzy,Den,
     +                         p0gm,p0hm,Vmax,Km,
     +                         Smn,nxm,nym,nzm,
     +                         imax,jmax,kmax,vc,coef)
c
      implicit none
c
      integer coef(1:3)
      integer imax,jmax,kmax,vc
      real qhm(-vc:imax+vc-1,-vc:jmax+vc-1,-vc:kmax+vc-1)
      real SW(-vc:imax+vc-1,-vc:jmax+vc-1,-vc:kmax+vc-1)
      real Fuzzy(-vc:imax+vc-1,-vc:jmax+vc-1,-vc:kmax+vc-1)
      real Den(-vc:imax+vc-1,-vc:jmax+vc-1,-vc:kmax+vc-1)
      real p0gm(-vc:imax+vc-1,-vc:jmax+vc-1,-vc:kmax+vc-1)
      real p0hm(-vc:imax+vc-1,-vc:jmax+vc-1,-vc:kmax+vc-1)
      real Vmax(-vc:imax+vc-1,-vc:jmax+vc-1,-vc:kmax+vc-1)
      real Km(-vc:imax+vc-1,-vc:jmax+vc-1,-vc:kmax+vc-1)
      real Smn(-vc:imax+vc-1,-vc:jmax+vc-1,-vc:kmax+vc-1)
      real nxm(-vc:imax+vc-1,-vc:jmax+vc-1,-vc:kmax+vc-1)
      real nym(-vc:imax+vc-1,-vc:jmax+vc-1,-vc:kmax+vc-1)
      real nzm(-vc:imax+vc-1,-vc:jmax+vc-1,-vc:kmax+vc-1)
      real TR
      real fluxpumptrvoxel
c
      integer i,j,k
      integer si,sj,sk
      integer cindex(1:3)
c
      cindex(1) = 0
      cindex(2) = 0
      cindex(3) = 0
      if( coef(1).eq.(1) ) cindex(1) = 1
      if( coef(2).eq.(1) ) cindex(2) = 1
      if( coef(3).eq.(1) ) cindex(3) = 1
c
      do k=0,kmax-1
      do j=0,jmax-1
      do i=0,imax-1
c
      si = i + cindex(1)
      sj = j + cindex(2)
      sk = k + cindex(3)
c
      qhm(i,j,k) = qhm(i,j,k) + Smn(si,sj,sk)
     +  * fluxpumptrvoxel(
     +      TR,SW,Fuzzy,Den,p0gm,p0hm,Vmax,Km,
     +      nxm(i,j,k),nym(i,j,k),nzm(i,j,k),i,j,k,
     +      imax,jmax,kmax,vc)
c
      enddo
      enddo
      enddo
c
      return
      end
