//Copyright (C) 2013 The Computational Science Resarch Program (CSRP), RIKEN
//All rights reserved.
//
c Copyright (C) 2013 The Computational Science Resarch Program (CSRP), RIKEN
c All rights reserved.
c This file is part of RIKEN Integrated Cell Simulator for the K-Computer(RICS-K).
c 
c  RICS-K is free software: you can redistribute it and/or modify
c it under the terms of the GNU General Public License as published by
c the Free Software Foundation, either version 3 of the License, or
c (at your option) any later version.
c
c RICS-K is distributed in the hope that it will be useful,
c but WITHOUT ANY WARRANTY; without even the implied warranty of
c MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c GNU General Public License for more details.
c 
c You should have received a copy of the GNU General Public License
c along with RICS-K.  If not, see <http://www.gnu.org/licenses/>.

      real function fluxchannelvoxel(
     +                      R,SW,Fuzzy,Den,
     +                      P0gm,P0gn,Evm,Evn,
     +                      KCha,KeCha,
     +                      nx,ny,nz,i,j,k,
     +                      imax,jmax,kmax,vc)
c
      implicit none
c
      integer i,j,k
      integer imax,jmax,kmax,vc
      real SW(-vc:imax+vc-1,-vc:jmax+vc-1,-vc:kmax+vc-1)
      real Fuzzy(-vc:imax+vc-1,-vc:jmax+vc-1,-vc:kmax+vc-1)
      real Den(-vc:imax+vc-1,-vc:jmax+vc-1,-vc:kmax+vc-1)
      real P0gm(-vc:imax+vc-1,-vc:jmax+vc-1,-vc:kmax+vc-1)
      real P0gn(-vc:imax+vc-1,-vc:jmax+vc-1,-vc:kmax+vc-1)
      real Evm(-vc:imax+vc-1,-vc:jmax+vc-1,-vc:kmax+vc-1)
      real Evn(-vc:imax+vc-1,-vc:jmax+vc-1,-vc:kmax+vc-1)
      real KCha(-vc:imax+vc-1,-vc:jmax+vc-1,-vc:kmax+vc-1)
      real KeCha(-vc:imax+vc-1,-vc:jmax+vc-1,-vc:kmax+vc-1)
      real nx, ny, nz
      real R
      real fluxchannel
c
      fluxchannelvoxel =
     +   + R
     +   * fluxchannel(
     +        SW(i,j,k),Fuzzy(i,j,k),Den(i,j,k),
     +        p0gm(i,j,k),
     +        P0gn(i+int(nx),j+int(ny),k+int(nz)),
     +        Evm(i,j,k),
     +        Evn(i+int(nx),j+int(ny),k+int(nz)),
     +        KCha(i,j,k),KeCha(i,j,k))
c
      return
      end

c
