c
c...calchh
c
      subroutine calchh(imax,jmax,kmax,vc,Cm,gK,gNa,gL,vK,vNa,vL,dt,
     1                  val,mm,nn,hh,dvdt,coefdvdt)
c
      implicit none
c
      integer imax,jmax,kmax,vc
c
      real Cm,gK,gNa,gL,vK,vNa,vL,Iapp,dt
      real val(     1-vc:imax+vc,1-vc:jmax+vc,1-vc:kmax+vc)
      real mm(      1-vc:imax+vc,1-vc:jmax+vc,1-vc:kmax+vc)
      real nn(      1-vc:imax+vc,1-vc:jmax+vc,1-vc:kmax+vc)
      real hh(      1-vc:imax+vc,1-vc:jmax+vc,1-vc:kmax+vc)
      real dvdt(    1-vc:imax+vc,1-vc:jmax+vc,1-vc:kmax+vc)
      real coefdvdt(1-vc:imax+vc,1-vc:jmax+vc,1-vc:kmax+vc)
c
      integer i,j,k
c
      real calcdv
c
c
      calcdv = 0.0d0
c
      do k=1,kmax
        do j=1,jmax
          do i=1,imax

             calcdv     =-gK*nn(i,j,k)**4*(val(i,j,k)-vK)
     1                  -gNa*mm(i,j,k)**3*hh(i,j,k)*(val(i,j,k)-vNa)
     2                  -gL*(val(i,j,k)-vL)
c            dvdt(i,j,k)=dvdt(i,j,k)*coefdvdt(i,j,k)
             dvdt(i,j,k)=dvdt(i,j,k)+calcdv*coefdvdt(i,j,k)

          enddo
        enddo
      enddo

c
      call calcmnh(imax,jmax,kmax,vc,dt,val,mm,nn,hh)
c
      return
      end
c
c
c...calc m, n, h
c
      subroutine calcmnh(imax,jmax,kmax,vc,dt,val,mm,nn,hh)
c
      implicit none
c
      integer imax,jmax,kmax,vc
c
      real dt
      real val(1-vc:imax+vc,1-vc:jmax+vc,1-vc:kmax+vc)
      real mm( 1-vc:imax+vc,1-vc:jmax+vc,1-vc:kmax+vc)
      real nn( 1-vc:imax+vc,1-vc:jmax+vc,1-vc:kmax+vc)
      real hh( 1-vc:imax+vc,1-vc:jmax+vc,1-vc:kmax+vc)
c
      real alm,aln,alh,bem,ben,beh
c
      integer i,j,k
c
c
      do k=1,kmax
        do j=1,jmax
          do i=1,imax
c
            alm=0.1*(25.0-val(i,j,k))/(exp((25.0-val(i,j,k))/10.0)-1.0)
            bem=4.0*exp(-val(i,j,k)/18.0)
            alh=0.07*exp(-val(i,j,k)/20.0)
            beh=1.0/(exp((30.0-val(i,j,k))/10.0)+1.0)
            aln=0.01*(10.0-val(i,j,k))/(exp((10.0-val(i,j,k))/10.0)-1.0)
            ben=0.125*exp(-val(i,j,k)/80.0)
c
            mm(i,j,k)=mm(i,j,k)+dt*(alm*(1.0-mm(i,j,k))-bem*mm(i,j,k))
            nn(i,j,k)=nn(i,j,k)+dt*(aln*(1.0-nn(i,j,k))-ben*nn(i,j,k))
            hh(i,j,k)=hh(i,j,k)+dt*(alh*(1.0-hh(i,j,k))-beh*hh(i,j,k))

C
c            if( i.eq.5 .and. j.eq.5 .and. k.eq.5 ) then
c              write(*,*) "i,j,k",i,j,k
c              write(*,*) "alm : ",alm
c              write(*,*) "bem : ",bem
c              write(*,*) "alh : ",alh
c              write(*,*) "beh : ",beh
c              write(*,*) "aln : ",aln
c              write(*,*) "ben : ",ben
c              write(*,*) "mm  : ",mm(i,j,k)
c              write(*,*) "nn  : ",nn(i,j,k)
c              write(*,*) "hh  : ",hh(i,j,k)
c            endif
c
          enddo
        enddo
      enddo
c
      return
      end

