//Copyright (C) 2013 The Computational Science Resarch Program (CSRP), RIKEN
//All rights reserved.
//
c Copyright (C) 2013 The Computational Science Resarch Program (CSRP), RIKEN
c All rights reserved.
c This file is part of RIKEN Integrated Cell Simulator for the K-Computer(RICS-K).
c 
c  RICS-K is free software: you can redistribute it and/or modify
c it under the terms of the GNU General Public License as published by
c the Free Software Foundation, either version 3 of the License, or
c (at your option) any later version.
c
c RICS-K is distributed in the hope that it will be useful,
c but WITHOUT ANY WARRANTY; without even the implied warranty of
c MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c GNU General Public License for more details.
c 
c You should have received a copy of the GNU General Public License
c along with RICS-K.  If not, see <http://www.gnu.org/licenses/>.

      subroutine differential_hh(
     +                    Flag,P,cx,cy,cz,ax,ay,az,dfx,dfy,dfz,
     +                    imax,jmax,kmax,vc,dxi,dyi,dzi)
c
      implicit none

      real temp
c
      integer Flag
      integer imax,jmax,kmax,vc
      real dxi,dyi,dzi
      real P  (1-vc:imax+vc,1-vc:jmax+vc,1-vc:kmax+vc)
      real cx (1-vc:imax+vc,1-vc:jmax+vc,1-vc:kmax+vc)
      real cy (1-vc:imax+vc,1-vc:jmax+vc,1-vc:kmax+vc)
      real cz (1-vc:imax+vc,1-vc:jmax+vc,1-vc:kmax+vc)
      real ax (1-vc:imax+vc,1-vc:jmax+vc,1-vc:kmax+vc)
      real ay (1-vc:imax+vc,1-vc:jmax+vc,1-vc:kmax+vc)
      real az (1-vc:imax+vc,1-vc:jmax+vc,1-vc:kmax+vc)
      real dfx(1-vc:imax+vc,1-vc:jmax+vc,1-vc:kmax+vc)
      real dfy(1-vc:imax+vc,1-vc:jmax+vc,1-vc:kmax+vc)
      real dfz(1-vc:imax+vc,1-vc:jmax+vc,1-vc:kmax+vc)
c
      integer i,j,k
      real axx,axe,axw,axn,axs,fxx,fxe,fxw,fxn,fxs
      real ayy,aye,ayw,ayn,ays,fyy,fye,fyw,fyn,fys
      real azz,aze,azw,azn,azs,fzz,fze,fzw,fzn,fzs
      real d6i
c
c...basic method
      if(Flag.eq.0) then
c
c     for X-direction
c
      do k=1,kmax
      do j=1,jmax
      do i=1,imax+1

        dfx(i,j,k)
     +    = ax(i,j,k)*cx(i,j,k)*(P(i,j,k)-P(i-1,j,k))*dxi

      enddo
      enddo
      enddo
c
c     for Y-direction
c
      do k=1,kmax
      do j=1,jmax+1
      do i=1,imax

        dfy(i,j,k)                                  
     +    = ay(i,j,k)*cy(i,j,k)*(P(i,j,k)-P(i,j-1,k))*dyi

      enddo
      enddo
      enddo
c
c     for Z-direction
c
      do k=1,kmax+1
      do j=1,jmax
      do i=1,imax

        dfz(i,j,k)                                  
     +    = az(i,j,k)*cz(i,j,k)*(P(i,j,k)-P(i,j,k-1))*dzi

      enddo
      enddo
      enddo

c...26way method
      else
        d6i=1.d0/6.d0
c
c     for X-direction
c
        do k=1,kmax
        do j=1,jmax
        do i=1,imax+1
          axx=ax(i,j,k)
          axe=ax(i,j+1,k)
          axw=ax(i,j-1,k)
          axn=ax(i,j,k+1)
          axs=ax(i,j,k-1)
          fxx=cx(i,j,k) * (P(i,j,k)-P(i-1,j,k)) * dxi
          fxe=cx(i,j+1,k) * (P(i,j+1,k)-P(i-1,j+1,k)) * dxi
          fxw=cx(i,j-1,k) * (P(i,j-1,k)-P(i-1,j-1,k)) * dxi
          fxn=cx(i,j,k+1) * (P(i,j,k+1)-P(i-1,j,k+1)) * dxi
          fxs=cx(i,j,k-1) * (P(i,j,k-1)-P(i-1,j,k-1)) * dxi
c
          if( axx+axe.ne.0.0 ) then
            fxe = (fxx*axx + fxe*axe)/(axx+axe)
          else
            fxe = 0.0
          endif
          if( axx+axw.ne.0.0 ) then
            fxw = (fxx*axx + fxw*axw)/(axx+axw)
          else
            fxw = 0.0
          endif
          if( axx+axn.ne.0.0 ) then
            fxn = (fxx*axx + fxn*axn)/(axx+axn)
          else
            fxn = 0.0
          endif
          if( axx+axs.ne.0.0 ) then
            fxs = (fxx*axx + fxs*axs)/(axx+axs)
          else
            fxs = 0.0
          endif
c       
          dfx(i,j,k) = (fxe+fxw+fxn+fxs+2.0*fxx)*d6i * axx
c
        enddo
        enddo
        enddo
c
c     for Y-direction
c
        do k=1,kmax
        do j=1,jmax+1
        do i=1,imax
          ayy=ay(i,j,k)
          aye=ay(i+1,j,k)
          ayw=ay(i-1,j,k)
          ayn=ay(i,j,k+1)
          ays=ay(i,j,k-1)
          fyy=cy(i,j,k) * (P(i,j,k)-P(i,j-1,k)) * dyi
          fye=cy(i+1,j,k) * (P(i+1,j,k)-P(i+1,j-1,k)) * dyi
          fyw=cy(i-1,j,k) * (P(i-1,j,k)-P(i-1,j-1,k)) * dyi
          fyn=cy(i,j,k+1) * (P(i,j,k+1)-P(i,j-1,k+1)) * dyi
          fys=cy(i,j,k-1) * (P(i,j,k-1)-P(i,j-1,k-1)) * dyi
c
          if( ayy+aye.ne.0.0 ) then
            fye = (fyy*ayy + fye*aye)/(ayy+aye)
          else
            fye = 0.0
          endif
          if( ayy+ayw.ne.0.0 ) then
            fyw = (fyy*ayy + fyw*ayw)/(ayy+ayw)
          else
            fyw = 0.0
          endif
          if( ayy+ayn.ne.0.0 ) then
            fyn = (fyy*ayy + fyn*ayn)/(ayy+ayn)
          else
            fyn = 0.0
          endif
          if( ayy+ays.ne.0.0 ) then
            fys = (fyy*ayy + fys*ays)/(ayy+ays)
          else
            fys = 0.0
          endif
c       
          dfy(i,j,k) = (fye+fyw+fyn+fys+2.0*fyy)*d6i * ayy
c
        enddo
        enddo
        enddo
c
c     for Z-direction
c
        do k=1,kmax+1
        do j=1,jmax
        do i=1,imax
          azz=az(i,j,k)
          aze=az(i+1,j,k)
          azw=az(i-1,j,k)
          azn=az(i,j+1,k)
          azs=az(i,j-1,k)
          fzz=cz(i,j,k) * (P(i,j,k)-P(i,j,k-1)) * dzi
          fze=cz(i+1,j,k) * (P(i+1,j,k)-P(i+1,j,k-1)) * dzi
          fzw=cz(i-1,j,k) * (P(i-1,j,k)-P(i-1,j,k-1)) * dzi
          fzn=cz(i,j+1,k) * (P(i,j+1,k)-P(i,j+1,k-1)) * dzi
          fzs=cz(i,j-1,k) * (P(i,j-1,k)-P(i,j-1,k-1)) * dzi
c
          if( azz+aze.ne.0.0 ) then
            fze = (fzz*azz + fze*aze)/(azz+aze)
          else
            fze = 0.0
          endif
          if( azz+azw.ne.0.0 ) then
            fzw = (fzz*azz + fzw*azw)/(azz+azw)
          else
            fzw = 0.0
          endif
          if( azz+azn.ne.0.0 ) then
            fzn = (fzz*azz + fzn*azn)/(azz+azn)
          else
            fzn = 0.0
          endif
          if( azz+azs.ne.0.0 ) then
            fzs = (fzz*azz + fzs*azs)/(azz+azs)
          else
            fzs = 0.0
          endif
c       
          dfz(i,j,k) = (fze+fzw+fzn+fzs+2.0*fzz)*d6i * azz
c
        enddo
        enddo
        enddo
      endif
c
      return
      end
