//Copyright (C) 2013 The Computational Science Resarch Program (CSRP), RIKEN
//All rights reserved.
//
c Copyright (C) 2013 The Computational Science Resarch Program (CSRP), RIKEN
c All rights reserved.
c This file is part of RIKEN Integrated Cell Simulator for the K-Computer(RICS-K).
c 
c  RICS-K is free software: you can redistribute it and/or modify
c it under the terms of the GNU General Public License as published by
c the Free Software Foundation, either version 3 of the License, or
c (at your option) any later version.
c
c RICS-K is distributed in the hope that it will be useful,
c but WITHOUT ANY WARRANTY; without even the implied warranty of
c MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c GNU General Public License for more details.
c 
c You should have received a copy of the GNU General Public License
c along with RICS-K.  If not, see <http://www.gnu.org/licenses/>.

      subroutine setbndcoef_hh(Dx,Dy,Dz,nID,m,mols,imax,jmax,kmax,vc)
c
      implicit none
c
      integer nID(0:5)
      integer mols,m
      integer imax,jmax,kmax,vc
      real Dx(1-vc:imax+vc,1-vc:jmax+vc,1-vc:kmax+vc,1:mols)
      real Dy(1-vc:imax+vc,1-vc:jmax+vc,1-vc:kmax+vc,1:mols)
      real Dz(1-vc:imax+vc,1-vc:jmax+vc,1-vc:kmax+vc,1:mols)
c
      integer i,j,k

c
c     boundary X
c
      if(nID(0).lt.0)then
          do k=1,kmax
          do j=1,jmax
              !Dx(-1,j,k,m) = Dx(0,j,k,m)
              Dx(0,j,k,m) = Dx(1,j,k,m)
          enddo
          enddo
      endif
      if(nID(1).lt.0)then
          do k=1,kmax
          do j=1,jmax
              !Dx(imax,j,k,m) = Dx(imax-1,j,k,m)
              Dx(imax+1,j,k,m) = Dx(imax,j,k,m)
          enddo
          enddo
      endif
c
c     boundary Y
c
      if(nID(2).lt.0)then
          do k=1,kmax
          do i=1,imax
              !Dy(i,-1,k,m) = Dy(i,0,k,m)
              Dy(i,0,k,m) = Dy(i,1,k,m)
          enddo
          enddo
      endif
      if(nID(3).lt.0)then
          do k=1,kmax
          do i=1,imax
              !Dy(i,jmax,k,m) = Dy(i,jmax-1,k,m)
              Dy(i,jmax+1,k,m) = Dy(i,jmax,k,m)
          enddo
          enddo
      endif
c
c     boundary Z
c
      if(nID(4).lt.0)then
          do j=1,jmax
          do i=1,imax
              !Dz(i,j,-1,m) = Dz(i,j,0,m)
              Dz(i,j,0,m) = Dz(i,j,1,m)
          enddo
          enddo
      endif
      if(nID(5).lt.0)then
          do j=1,jmax
          do i=1,imax
              !Dz(i,j,kmax,m) = Dz(i,j,kmax-1,m)
              Dz(i,j,kmax+1,m) = Dz(i,j,kmax,m)
          enddo
          enddo
      endif
c
      return
      end

