/*
 * Copyright (c) RIKEN, Japan. All right reserved. 2008-2009
 *
 */

#ifndef __WARP_GROUP_H__
#define __WARP_GROUP_H__

#include "WarpBase.h"
#include "WarpInfo.h"

class WarpGroup : public WarpBase
{
protected:

// member variables

	// warp information list
	vector<WarpInfo*> m_warpInfo;

	// temporary area for Mediation
	WarpTemporaryArea m_tempArea;

	// E-Cell simulator for Mediation
	// emcsim* m_emcsim;

	// Temporart Area Volume
	// SKL_REAL tempAreaVolume;

// member functions
	bool CalcDirect();
	bool CalcMediation();
	bool CalcCapillary();
	bool CalcUser();

public:

// member functions
  WarpGroup(const CfgInfo& _cfg, int cnt);
  virtual ~WarpGroup();
	bool ParseXML(const CfgElem* elemRoot);
	virtual bool printLog(stringstream& wout, int ts, int nid=-1);

	E_WARP_TYPE GetWarpType();

	// bool checkEcellExec();
	bool EcellInitialize();

	bool Calc();
};

#endif  /*__WARP_GROUP_H__*/
