/*
 * Copyright (c) RIKEN, Japan. All right reserved. 2008-2009
 *
 */

#ifndef __WARP_INFO_H__
#define __WARP_INFO_H__

#include "WarpBase.h"
#include "WarpMolInfo.h"

class WarpInfo : public WarpBase
{
protected:

// member variables

	WarpMolInfo* m_srcMolInfo;
	WarpMolInfo* m_dstMolInfo;
	WarpMolInfo* m_srcTrigger;
	WarpMolInfo* m_dstTrigger;

// member functions
	
	// for Direct
	bool CalcDirect_Source(WarpTemporaryArea *tempArea);
	bool CalcDirect_Distination(WarpTemporaryArea *tempArea);

	// for Mediation
	bool CalcMediation_Source(WarpTemporaryArea *tempArea);
	bool CalcMediation_Distination(WarpTemporaryArea *tempArea);

public:

// member functions
  WarpInfo(const CfgInfo& _cfg, int cnt);
  virtual ~WarpInfo();
	bool ParseXML(const CfgElem* elemRoot, WarpTemporaryArea* tempArea);
	bool CheckWarpInfo(E_WARP_TYPE warpType);
	virtual bool printLog(stringstream& wout, int ts, int nid=-1);

	bool CalcDirect(WarpTemporaryArea *tempArea);
	bool CalcMediation(WarpTemporaryArea *tempArea);
	bool CalcCapillary(WarpTemporaryArea *tempArea);
	bool CalcUser(WarpTemporaryArea *tempArea);

};

#endif  /*__WARP_INFO_H__*/

