//Copyright (C) 2013 The Computational Science Resarch Program (CSRP), RIKEN
//All rights reserved.
//
//This file is part of RIKEN Integrated Cell Simulator for the K-Computer(RICS-K).
//
//RICS-K is free software: you can redistribute it and/or modify
//it under the terms of the GNU General Public License as published by
//the Free Software Foundation, either version 3 of the License, or
//(at your option) any later version.
//
//RICS-K is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with RICS-K.  If not, see <http://www.gnu.org/licenses/>.


#ifndef __WARP_SOLV_H__
#define __WARP_SOLV_H__

#include "WarpDefine.h"
#include "WarpGroup.h"

class WarpSolv
{
protected:

// member variables
	const CfgInfo& cfg;

	// warp parameters
	bool enableWarp;
	vector<WarpGroup*> m_warpGrp;

	// for time mesurement
	double clock;
	double comm_clk;

	// for parallel
	SklParaComponent* para_cmp;
	SklParaManager*   para_mng;


// member functions
	bool Allocate();
	bool printLog(int nid=-1);

public:

// member functions
	WarpSolv(const CfgInfo& _cfg);
	virtual ~WarpSolv();
	int WarpInitialize(const CfgElem* simElem, const CfgElem* warpRoot);
	int WarpLoop();
	int WarpPost();
	bool ParseXML(const CfgElem* warpElem);
	bool chkCfg();

	double GetClock()   const { return clock;    }
	double GetCommClk() const { return comm_clk; }

};

#endif /*__WARP_SOLV_H__*/

