## written by Ayako Yachie <ayakosan at sc.itc.keio.ac.jp>
## A model for van der Pol Oscillator

Stepper FixedODE1Stepper( FDE )
{
	StepInterval 0.004;
}


System System( / )
{
	StepperID	FDE;

 	Variable Variable( SIZE ) { Value 1000.0; }

 	Variable Variable( X )
	{
		Value	0.1;
	}

	Variable Variable( Y )
	{
		Value	0.2;
	}

	Process	ExpressionFluxProcess( delX )
	{
		VariableReferenceList	[ P0 :.:X 1 ]
					[ C0 :.:Y 0 ];
		
	#Expression "( P0.Value - pow(P0.Value,3)/3 + C0.Value)";
	Expression "( 30.0 * ( 3.0 * P0.Value * ( 1.0 - P0.Value ) * ( P0.Value - 0.001 ) - C0.Value ) )";
	#Expression "( ( 30.0 * ( 3.0 * ( P0.MolarConc * 1000.0 ) * ( 1.0 - ( P0.MolarConc * 1000.0 ) ) * ( ( P0.MolarConc * 1000.0 ) - 0.001 ) - ( C0.MolarConc * 1000.0 ) ) ) * ( self.getSuperSystem().SizeN_A / 1000.0 ) )";
	} 

	Process	ExpressionFluxProcess( delY )
	{
		VariableReferenceList	[ P0 :.:Y 1 ]
				[ C0 :.:X 0 ];
		Expression "( C0.Value - P0.Value )";
	#	Expression "( ( ( C0.MolarConc * 1000.0 ) - ( P0.MolarConc * 1000.0 ) ) * ( self.getSuperSystem().SizeN_A / 1000.0 ) )";
	} 	  
}
