cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c Make Volume Data
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine makevolume(vf,imax,jmax,kmax,vc,
     +                      xmin,xmax,ymin,ymax,zmin,zmax,
     +                      hix,hiy,hiz,mask)
c
      implicit none
c
      integer imax,jmax,kmax,vc
      integer xmin,xmax,ymin,ymax,zmin,zmax
      integer hix,hiy,hiz
c
      real vf(1-vc:imax+vc,1-vc:jmax+vc,1-vc:kmax+vc)
      integer mask(1-vc:imax+vc,1-vc:jmax+vc,1-vc:kmax+vc)
c
      integer i,j,k
      integer is,js,ks,ie,je,ke
      integer xminL,xmaxL,yminL,ymaxL,zminL,zmaxL
c
      xmin = xmin + 1
      ymin = ymin + 1
      zmin = zmin + 1
      xmax = xmax + 1
      ymax = ymax + 1
      zmax = zmax + 1

c ... Local Index
      xminL = xmin - hix
      yminL = ymin - hiy
      zminL = zmin - hiz
      xmaxL = xmax - hix
      ymaxL = ymax - hiy
      zmaxL = zmax - hiz
c
c ... mask init
      do k=1-vc,kmax+vc
      do j=1-vc,jmax+vc
      do i=1-vc,imax+vc
        mask(i,j,k) = 0
      enddo
      enddo
      enddo
c
c ... Material Volume start & end Index
      is = max(   1-vc,xminL)
      js = max(   1-vc,yminL)
      ks = max(   1-vc,zminL)
      ie = min(imax+vc,xmaxL)
      je = min(jmax+vc,ymaxL)
      ke = min(kmax+vc,zmaxL)
c
      do k=ks,ke
      do j=js,je
      do i=is,ie
        mask(i,j,k) = 8
      enddo
      enddo
      enddo
c
c ... Membrane
      do k=1,kmax
      do j=1,jmax
      do i=1,imax
        if( mask(i,j,k).gt.0 .and. mask(i-1,j,k).eq.0 ) then
          mask(i,j,k) = mask(i,j,k) / 2
        endif
        if( mask(i,j,k).gt.0 .and. mask(i+1,j,k).eq.0 ) then
          mask(i,j,k) = mask(i,j,k) / 2
        endif
        if( mask(i,j,k).gt.0 .and. mask(i,j-1,k).eq.0 ) then
          mask(i,j,k) = mask(i,j,k) / 2
        endif
        if( mask(i,j,k).gt.0 .and. mask(i,j+1,k).eq.0 ) then
          mask(i,j,k) = mask(i,j,k) / 2
        endif
        if( mask(i,j,k).gt.0 .and. mask(i,j,k-1).eq.0 ) then
          mask(i,j,k) = mask(i,j,k) / 2
        endif
        if( mask(i,j,k).gt.0 .and. mask(i,j,k+1).eq.0 ) then
          mask(i,j,k) = mask(i,j,k) / 2
        endif
      enddo
      enddo
      enddo
c
c ... Calc and Set Vf
      do k=1,kmax
      do j=1,jmax
      do i=1,imax
        vf(i,j,k) = dble(mask(i,j,k))/8.0
      enddo
      enddo
      enddo
c
      return
      end
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c Make GLC2Hx Volume
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine makevolume111(vf,imax,jmax,kmax,vc,
     +                      xmin,xmax,ymin,ymax,zmin,zmax,
     +                      hix,hiy,hiz,mask)
c
      implicit none
c
      integer imax,jmax,kmax,vc
      integer xmin,xmax,ymin,ymax,zmin,zmax
      integer hix,hiy,hiz
c
      real vf(0-vc:imax+vc-1,0-vc:jmax+vc-1,0-vc:kmax+vc-1)
c
      integer i,j,k
      integer is,js,ks,ie,je,ke
      integer mask(0-vc:imax+vc-1,0-vc:jmax+vc-1,0-vc:kmax+vc-1)
c
c ... mask init
      do k=0-vc,kmax+vc-1
      do j=0-vc,jmax+vc-1
      do i=0-vc,imax+vc-1
        mask(i,j,k) = -1
      enddo
      enddo
      enddo

c ... X Loop setting
      if( (0-vc+hix).gt.xmin ) then
        is = (0-vc)
      else
        is = xmin - hix
      endif

      if( (imax+vc-1+hix).lt.xmax ) then
        ie = (imax+vc-1)
      else
        ie = xmax - hix
      endif

c ... Y Loop setting
      if( (0-vc+hiy).gt.ymin ) then
        js = (0-vc)
      else
        js = ymin - hiy
      endif

      if( (jmax+vc-1+hiy).lt.ymax ) then
        je = (jmax+vc-1)
      else
        je = ymax - hiy
      endif

c ... Z Loop setting
      if( (0-vc+hiz).gt.zmin ) then
        ks = (0-vc)
      else
        ks = zmin - hiz
      endif

      if( (kmax+vc-1+hiz).lt.zmax ) then
        ke = (kmax+vc-1)
      else
        ke = zmax - hiz
      endif

c ... mask
      do k=ks,ke
      do j=js,je
      do i=is,ie
        mask(i,j,k) = 0
        if( ((i+hix).gt.xmin) .and. ((i+hix).lt.xmax) ) then
          mask(i,j,k) = mask(i,j,k) + 1
        endif
        if( ((j+hiy).gt.ymin) .and. ((j+hiy).lt.ymax) ) then
          mask(i,j,k) = mask(i,j,k) + 1
        endif
        if( ((k+hiz).gt.zmin) .and. ((k+hiz).lt.zmax) ) then
          mask(i,j,k) = mask(i,j,k) + 1
        endif
      enddo
      enddo
      enddo

c ... vf set
      do k=0-vc,kmax+vc-1
      do j=0-vc,jmax+vc-1
      do i=0-vc,imax+vc-1
        if( mask(i,j,k).eq.3 ) then
          vf(i,j,k) = 1.0
        else if( mask(i,j,k).eq.2 ) then
          vf(i,j,k) = 0.5
        else if( mask(i,j,k).eq.1 ) then
          vf(i,j,k) = 0.25
        else if( mask(i,j,k).eq.0 ) then
          vf(i,j,k) = 0.125
        else
          vf(i,j,k) = 0.0
        endif
      enddo
      enddo
      enddo
c
      return
      end
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c Set Open Area Ratio
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine setOpenAreaRatio(vf,ax,ay,az,vc,imax,jmax,kmax)
c
      implicit none
c
      integer imax,jmax,kmax,vc
c
      real vf(0-vc:imax+vc-1,0-vc:jmax+vc-1,0-vc:kmax+vc-1)
      real ax(0-vc:imax+vc-1,0-vc:jmax+vc-1,0-vc:kmax+vc-1)
      real ay(0-vc:imax+vc-1,0-vc:jmax+vc-1,0-vc:kmax+vc-1)
      real az(0-vc:imax+vc-1,0-vc:jmax+vc-1,0-vc:kmax+vc-1)
c
      integer i,j,k
c
c ... ax
      do k=0,kmax-1
      do j=0,jmax-1
      do i=0,imax
        if((vf(i-1,j,k).eq.0.0).or.(vf(i,j,k).eq.0.0)) then
          ax(i,j,k) = 0.0
        else if((vf(i-1,j,k).eq.1.0).or.(vf(i,j,k).eq.1.0)) then
          ax(i,j,k) = 1.0
        else
          ax(i,j,k) = (vf(i-1,j,k)+vf(i,j,k))*0.5
        endif
      enddo
      enddo
      enddo
c
c ... ay
      do k=0,kmax-1
      do j=0,jmax
      do i=0,imax-1
        if((vf(i,j-1,k).eq.0.0).or.(vf(i,j,k).eq.0.0)) then
          ay(i,j,k) = 0.0
        else if((vf(i,j-1,k).eq.1.0).or.(vf(i,j,k).eq.1.0)) then
          ay(i,j,k) = 1.0
        else
          ay(i,j,k) = (vf(i,j-1,k)+vf(i,j,k))*0.5
        endif
      enddo
      enddo
      enddo
c
c ... az
      do k=0,kmax
      do j=0,jmax-1
      do i=0,imax-1
        if((vf(i,j,k-1).eq.0.0).or.(vf(i,j,k).eq.0.0)) then
          az(i,j,k) = 0.0
        else if((vf(i,j,k-1).eq.1.0).or.(vf(i,j,k).eq.1.0)) then
          az(i,j,k) = 1.0
        else
          az(i,j,k) = (vf(i,j,k-1)+vf(i,j,k))*0.5
        endif
      enddo
      enddo
      enddo
c
      return
      end
