cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c ricscpys3d ... copy array
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine ricscpys3d(dst,src,imax,jmax,kmax,vc)
c
      implicit none
c
      integer imax,jmax,kmax,vc
      real dst(0-vc:imax+vc-1,0-vc:jmax+vc-1,0-vc:kmax+vc-1)
      real src(0-vc:imax+vc-1,0-vc:jmax+vc-1,0-vc:kmax+vc-1)
c
      integer i,j,k
c
      do k=0-vc,kmax+vc-1
      do j=0-vc,jmax+vc-1
      do i=0-vc,imax+vc-1
        dst(i,j,k) = src(i,j,k)
      enddo
      enddo
      enddo
c
      return
      end
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c ricscpys3dss ... copy array (steady state)
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine ricscpys3dss(dst,src,imax,jmax,kmax,dvc,svc)
c
      implicit none
c
      integer imax,jmax,kmax,dvc,svc
      real dst(0-dvc:imax+dvc-1,0-dvc:jmax+dvc-1,0-dvc:kmax+dvc-1)
      real src(0-svc:imax+svc-1,0-svc:jmax+svc-1,0-svc:kmax+svc-1)
c
      integer i,j,k
c
      do k=0-dvc,kmax+dvc-1
      do j=0-dvc,jmax+dvc-1
      do i=0-dvc,imax+dvc-1
        dst(i,j,k) = src(i,j,k)
      enddo
      enddo
      enddo
c
      return
      end
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c ricscpys3dsendrecv ... copy array Parallel.C (SendRecv)
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine ricscpys3dsendrecv(
     +             dst,src,dvc,svc,imax,jmax,kmax,vc)
c
      implicit none
c
      integer imax,jmax,kmax,vc
      integer dvc,svc
      real dst(0-dvc:imax+dvc-1,0-dvc:jmax+dvc-1,0-dvc:kmax+dvc-1)
      real src(0-svc:imax+svc-1,0-svc:jmax+svc-1,0-svc:kmax+svc-1)
c
      integer i,j,k
c
      do k=0-vc,kmax+vc-1
      do j=0-vc,jmax+vc-1
      do i=0-vc,imax+vc-1
        dst(i,j,k) = src(i,j,k)
      enddo
      enddo
      enddo
c
      return
      end
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c ricscpys3dareacomm ... copy array AreaCommLink.C
c                          (Send, Recv)
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine ricscpys3dareacomm(
     +             dst,dimax,djmax,dkmax,dvc,
     +             src,simax,sjmax,skmax,svc,
     +             wrhi,wrhj,wrhk,svrhi,svrhj,svrhk,vc)
c
      implicit none
c
      integer wrhi,wrhj,wrhk
      integer svrhi,svrhj,svrhk
      integer dimax,djmax,dkmax,dvc
      integer simax,sjmax,skmax,svc
      real dst(0-dvc:dimax+dvc-1,0-dvc:djmax+dvc-1,0-dvc:dkmax+dvc-1)
      real src(0-svc:simax+svc-1,0-svc:sjmax+svc-1,0-svc:skmax+svc-1)
      integer vc
c
      integer i,j,k
      integer si,sj,sk
c
      do k=0-vc,dkmax+vc-1
      do j=0-vc,djmax+vc-1
      do i=0-vc,dimax+vc-1
        si = i + wrhi - svrhi
        sj = j + wrhj - svrhj
        sk = k + wrhk - svrhk

        dst(i,j,k) = src(si,sj,sk)
      enddo
      enddo
      enddo
c
      return
      end
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c ricscpys3dcoef ... rrtmp = rr * c
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine ricscpys3dcoef(
     +                  dst,src,imax,jmax,kmax,vc,coef)
c
      implicit none
c
      integer imax,jmax,kmax,vc
      real coef
      real dst(0-vc:imax+vc-1,0-vc:jmax+vc-1,0-vc:kmax+vc-1)
      real src(0-vc:imax+vc-1,0-vc:jmax+vc-1,0-vc:kmax+vc-1)
c
      integer i,j,k
c
      do k=0-vc,kmax+vc-1
      do j=0-vc,jmax+vc-1
      do i=0-vc,imax+vc-1
        dst(i,j,k) = src(i,j,k) * coef
      enddo
      enddo
      enddo
c
      return
      end
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c ricsadds3dcoef ... rrtmp = rrtmp + rr * c
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine ricsadds3dcoef(
     +                  dst,src,imax,jmax,kmax,vc,coef)
c
      implicit none
c
      integer imax,jmax,kmax,vc
      real coef
      real dst(0-vc:imax+vc-1,0-vc:jmax+vc-1,0-vc:kmax+vc-1)
      real src(0-vc:imax+vc-1,0-vc:jmax+vc-1,0-vc:kmax+vc-1)
c
      integer i,j,k
c
      do k=0-vc,kmax+vc-1
      do j=0-vc,jmax+vc-1
      do i=0-vc,imax+vc-1
        dst(i,j,k) = dst(i,j,k) + src(i,j,k) * coef
      enddo
      enddo
      enddo
c
      return
      end
