ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
//Copyright (C) 2013 The Computational Science Resarch Program (CSRP), RIKEN
//All rights reserved.
//
c Copyright (C) 2013 The Computational Science Resarch Program (CSRP), RIKEN
c All rights reserved.
c This file is part of RIKEN Integrated Cell Simulator for the K-Computer(RICS-K).
c 
c  RICS-K is free software: you can redistribute it and/or modify
c it under the terms of the GNU General Public License as published by
c the Free Software Foundation, either version 3 of the License, or
c (at your option) any later version.
c
c RICS-K is distributed in the hope that it will be useful,
c but WITHOUT ANY WARRANTY; without even the implied warranty of
c MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c GNU General Public License for more details.
c 
c You should have received a copy of the GNU General Public License
c along with RICS-K.  If not, see <http://www.gnu.org/licenses/>.

c   calc advection
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine calc_advection(p0,ad,uvel,vvel,wvel,vfi,ax,ay,az,
     +                          ni,nj,nk,vc,dx,dy,dz)
c
      implicit none
c
      integer ni,nj,nk
      integer vc
      real dx,dy,dz
c
      real   p0(1-vc:ni+vc,1-vc:nj+vc,1-vc:nk+vc)
      real   ad(1-vc:ni+vc,1-vc:nj+vc,1-vc:nk+vc)
      real uvel(1-vc:ni+vc,1-vc:nj+vc,1-vc:nk+vc)
      real vvel(1-vc:ni+vc,1-vc:nj+vc,1-vc:nk+vc)
      real wvel(1-vc:ni+vc,1-vc:nj+vc,1-vc:nk+vc)
      real  vfi(1-vc:ni+vc,1-vc:nj+vc,1-vc:nk+vc)
      real   ax(1-vc:ni+vc,1-vc:nj+vc,1-vc:nk+vc)
      real   ay(1-vc:ni+vc,1-vc:nj+vc,1-vc:nk+vc)
      real   az(1-vc:ni+vc,1-vc:nj+vc,1-vc:nk+vc)
c
      integer i,j,k
      real dxi,dyi,dzi
      real adx,ady,adz
c
      dxi = 1.0d0 / dx
      dyi = 1.0d0 / dy
      dzi = 1.0d0 / dz
c
      do k=1,nk
      do j=1,nj
      do i=1,ni
        adx = (
     +    (ax(i+1,j,k)*uvel(i+1,j,k)*(p0(i+1,j,k)+p0(i,j,k))*0.5)
     +  - (ax(i  ,j,k)*uvel(i  ,j,k)*(p0(i,j,k)+p0(i-1,j,k))*0.5)
     +               ) * dxi

        ad(i,j,k) = adx
      enddo
      enddo
      enddo

      do k=1,nk
      do j=1,nj
      do i=1,ni
        ady = (
     +    (ay(i,j+1,k)*vvel(i,j+1,k)*(p0(i,j+1,k)+p0(i,j,k))*0.5)
     +  - (ay(i,j  ,k)*vvel(i,j  ,k)*(p0(i,j,k)+p0(i,j-1,k))*0.5)
     +               ) * dyi

        ad(i,j,k) = ad(i,j,k) + ady
      enddo
      enddo
      enddo

      do k=1,nk
      do j=1,nj
      do i=1,ni
        adz = (
     +    (az(i,j,k+1)*wvel(i,j,k+1)*(p0(i,j,k+1)+p0(i,j,k))*0.5)
     +  - (az(i,j,k  )*wvel(i,j,k  )*(p0(i,j,k)+p0(i,j,k-1))*0.5)
     +               ) * dzi

        ad(i,j,k) = ad(i,j,k) + adz
      enddo
      enddo
      enddo

      do k=1,nk
      do j=1,nj
      do i=1,ni
        ad(i,j,k) = ad(i,j,k) * vfi(i,j,k)
      enddo
      enddo
      enddo
c
      return
      end
c
